Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1539)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1551)
@@ -816,149 +1019,162 @@
 !
 !--          Calculate fraction of liquid water reservoir
-             m_liq_max = m_max_depth * LAI(j,i)
-             c_liq(j,i) = MIN(1.0_wp, m_liq(j,i)/m_liq_max)
-
+             m_liq_eb_max = m_max_depth * lai(j,i)
+             c_liq(j,i) = MIN(1.0_wp, m_liq_eb(j,i) / (m_liq_eb_max+1.0E-20_wp))
+             
+
+!
+!--          Calculate saturation specific humidity
              q_s = 0.622_wp * e_s / surface_pressure
 
 !
-!--          In case of dew fall, set resistances to zero.
-!--          To do: what does that physically reasoning behind this?
+!--          In case of dewfall, set evapotranspiration to zero
+!--          All super-saturated water is then removed from the air
+             IF ( humidity .AND. dewfall .AND. q_s .LE. q_p(k+1,j,i) )  THEN
+                r_canopy(j,i) = 0.0_wp
+                r_soil(j,i)   = 0.0_wp
+             ENDIF 
+
+!
+!--          Calculate coefficients for the total evapotranspiration 
+             f_qsws_veg  = rho_lv * c_veg(j,i) * (1.0_wp - c_liq(j,i))/        &
+                           (r_a(j,i) + r_canopy(j,i))
+
+             f_qsws_soil = rho_lv * (1.0_wp - c_veg(j,i)) / (r_a(j,i) +        &
+                                                          r_soil(j,i))
+             f_qsws_liq  = rho_lv * c_veg(j,i) * c_liq(j,i) / r_a(j,i)
+
+
+!
+!--          If soil moisture is below wilting point, plants do no longer
+!--          transpirate.
+!              IF ( m_soil(k,j,i) .LT. m_wilt(j,i) )  THEN
+!                 f_qsws_veg = 0.0_wp
+!              ENDIF
+
+!
+!--          If dewfall is deactivated, vegetation, soil and liquid water
+!--          reservoir are not allowed to take up water from the super-saturated
+!--          air.
              IF ( humidity )  THEN
                 IF ( q_s .LE. q_p(k+1,j,i) )  THEN
-                   r_canopy(j,i) = 0.0_wp
-                   r_soil(j,i) = 0.0_wp
+                   IF ( .NOT. dewfall )  THEN
+                      f_qsws_veg  = 0.0_wp
+                      f_qsws_soil = 0.0_wp
+                      f_qsws_liq  = 0.0_wp
+                   ENDIF
                 ENDIF
              ENDIF 
 
-
-!
-!--          Calculate coefficients for the total evapotranspiration 
-             f_LE_veg  = rho_lv * c_veg(j,i) * (1.0 - c_liq(j,i)) / (r_a(j,i)  &
-                                                + r_canopy(j,i))
-             f_LE_soil = rho_lv * (1.0 - c_veg(j,i)) / (r_a(j,i) + r_soil(j,i))
-             f_LE_liq  = rho_lv * c_veg(j,i) * c_liq(j,i) / r_a(j,i)
-
-
-!
-!--          If soil moisture is below wilting point, plants do no longer
-!--          transpirate.
-             IF ( m_soil(k,j,i) .LT. m_wilt(j,i) )  THEN
-                f_LE_veg = 0.0
+             f_shf  = rho_cp / r_a(j,i)
+             f_qsws = f_qsws_veg + f_qsws_soil + f_qsws_liq
+
+!
+!--          Calculate derivative of q_s for Taylor series expansion
+             e_s_dT = e_s * ( 17.269_wp / (t_surface(j,i) - 35.86_wp) -        &
+                              17.269_wp*(t_surface(j,i) - 273.16_wp)           &
+                              / (t_surface(j,i) - 35.86_wp)**2 )
+
+             dq_s_dT = 0.622_wp * e_s_dT / surface_pressure
+
+             T_1 = pt_p(k+1,j,i) * exn
+
+!
+!--          Add LW up so that it can be removed in prognostic equation
+             rad_net(j,i) = rad_net(j,i) + sigma_SB * t_surface(j,i) ** 4
+
+             IF ( humidity )  THEN
+
+!
+!--             Numerator of the prognostic equation
+                coef_1 = rad_net(j,i) + 3.0_wp * sigma_SB * t_surface(j,i) ** 4&
+                         + f_shf / exn * T_1 + f_qsws * ( q_p(k+1,j,i) - q_s   &
+                         + dq_s_dT * t_surface(j,i) ) + lambda_surface         &
+                         * t_soil(nzb_soil,j,i)
+
+!
+!--             Denominator of the prognostic equation
+                coef_2 = 4.0_wp * sigma_SB * t_surface(j,i) ** 3 + f_qsws      &
+                         * dq_s_dT + lambda_surface + f_shf / exn
+
+             ELSE
+
+!
+!--             Numerator of the prognostic equation
+                coef_1 = rad_net(j,i) + 3.0_wp * sigma_SB * t_surface(j,i) ** 4&
+                         + f_shf / exn * T_1 + lambda_surface                  &
+                         * t_soil(nzb_soil,j,i)
+
+!
+!--             Denominator of the prognostic equation
+                coef_2 = 4.0_wp * sigma_SB * t_surface(j,i) ** 3               &
+                         + lambda_surface + f_shf / exn
+
              ENDIF
 
-             f_H  = rho_cp / r_a(j,i)
-             f_LE = f_LE_veg + f_LE_soil + f_LE_liq
-       
-!
-!--          Calculate derivative of q_s for Taylor series expansion
-             e_s_dT = e_s * ( 17.269_wp / (T_0(j,i) - 35.86_wp) -              &
-                              17.269_wp*(T_0(j,i) - 273.16_wp) / (T_0(j,i)     &
-                              - 35.86_wp)**2 )
-
-             dq_s_dT = 0.622_wp * e_s_dT / surface_pressure
-
-             T_1 = pt_p(k+1,j,i) * exn
-
-!
-!--          Add LW up so that it can be removed in prognostic equation
-             Rn(j,i) = Rn(j,i) + sigma_SB * T_0(j,i) ** 4
-
-             IF ( humidity )  THEN
-
-!
-!--             Numerator of the prognostic equation
-                coef_1 = Rn(j,i) + 3.0_wp * sigma_SB * T_0(j,i) ** 4 + f_H     &
-                         / exn * T_1 + f_LE * ( q_p(k+1,j,i) - q_s + dq_s_dT   &
-                         * T_0(j,i) ) + lambda_skin * T_soil(0,j,i)
-
-!
-!--             Denominator of the prognostic equation
-                coef_2 = 4.0_wp * sigma_SB * T_0(j,i) ** 3 + f_LE * dq_s_dT    &
-                         + lambda_skin + f_H / exn
-
-             ELSE
-
-!
-!--             Numerator of the prognostic equation
-                coef_1 = Rn(j,i) + 3.0_wp * sigma_SB * T_0(j,i) ** 4 + f_H /   &
-                         exn * T_1 + lambda_skin * T_soil(0,j,i)
-
-!
-!--             Denominator of the prognostic equation
-                coef_2 = 4.0_wp * sigma_SB * T_0(j,i) ** 3                     &
-                         + lambda_skin + f_H / exn
-
-             ENDIF
-
              tend = 0.0_wp
 
 !
-!--          Implicit solution when the skin layer has no heat capacity,
+!--          Implicit solution when the surface layer has no heat capacity,
 !--          otherwise use RK3 scheme.
-             T_0_p(j,i) = ( coef_1 * dt_3d * tsc(2) + C_skin * T_0(j,i) ) /    &
-                          ( C_skin + coef_2 * dt_3d * tsc(2) ) 
-
+             t_surface_p(j,i) = ( coef_1 * dt_3d * tsc(2) + c_surface *        &
+                                t_surface(j,i) ) / ( c_surface + coef_2 * dt_3d&
+                                * tsc(2) ) 
 !
 !--          Add RK3 term
-             T_0_p(j,i) = T_0_p(j,i) + dt_3d * tsc(3) * tT_soil_m(0,j,i)
+             t_surface_p(j,i) = t_surface_p(j,i) + dt_3d * tsc(3)              &
+                                * tt_surface_m(j,i)
 
 !
 !--          Calculate true tendency
-             tend = (T_0_p(j,i) - T_0(j,i) - tsc(3) * tT_0_m(j,i)) / (dt_3d    &
-                      * tsc(2))
-
-!
-!--          Calculate T_0 tendencies for the next Runge-Kutta step
+             tend = (t_surface_p(j,i) - t_surface(j,i) - dt_3d * tsc(3)        &
+                    * tt_surface_m(j,i)) / (dt_3d  * tsc(2))
+!
+!--          Calculate t_surface tendencies for the next Runge-Kutta step
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   tT_0_m(j,i) = tend
+                   tt_surface_m(j,i) = tend
                 ELSEIF ( intermediate_timestep_count <                         &
                          intermediate_timestep_count_max )  THEN
-                   tT_0_m(j,i) = -9.5625_wp * tend + 5.3125_wp * tT_0_m(j,i)
+                   tt_surface_m(j,i) = -9.5625_wp * tend + 5.3125_wp           &
+                                       * tt_surface_m(j,i)
                 ENDIF
              ENDIF
 
-             pt_p(k,j,i) = T_0_p(j,i) / exn
+             pt_p(k,j,i) = t_surface_p(j,i) / exn
 !
 !--          Calculate fluxes
-             Rn(j,i)        = Rn(j,i) + 3.0_wp * sigma_SB * T_0(j,i)**4        &
-                              - 4.0_wp * sigma_SB * T_0(j,i)**3 * T_0_p(j,i)
-             G(j,i)         = lambda_skin * (T_0_p(j,i) - T_soil(0,j,i))
-             H(j,i)         = - f_H  * ( pt_p(k+1,j,i) - pt_p(k,j,i) )
+             rad_net(j,i)   = rad_net(j,i) + 3.0_wp * sigma_SB                 &
+                              * t_surface(j,i)**4 - 4.0_wp * sigma_SB          &
+                              * t_surface(j,i)**3 * t_surface_p(j,i)
+             ghf_eb(j,i)    = lambda_surface * (t_surface_p(j,i)               &
+                              - t_soil(nzb_soil,j,i))
+             shf_eb(j,i)    = - f_shf  * ( pt_p(k+1,j,i) - pt_p(k,j,i) )
 
              IF ( humidity )  THEN
-                LE(j,i)        = - f_LE      * ( q_p(k+1,j,i) - q_s + dq_s_dT  &
-                                   * T_0(j,i) - dq_s_dT * T_0_p(j,i) )
-
-                LE_veg(j,i)    = - f_LE_veg  * ( q_p(k+1,j,i) - q_s + dq_s_dT  &
-                                   * T_0(j,i) - dq_s_dT * T_0_p(j,i) )
-                LE_soil(j,i)   = - f_LE_soil * ( q_p(k+1,j,i) - q_s + dq_s_dT  &
-                                   * T_0(j,i) - dq_s_dT * T_0_p(j,i) )
-                LE_liq(j,i)    = - f_LE_liq  * ( q_p(k+1,j,i) - q_s + dq_s_dT  &
-                                   * T_0(j,i) - dq_s_dT * T_0_p(j,i) )
+                qsws_eb(j,i)  = - f_qsws    * ( q_p(k+1,j,i) - q_s + dq_s_dT   &
+                                * t_surface(j,i) - dq_s_dT * t_surface_p(j,i) )
+
+                qsws_veg_eb(j,i)  = - f_qsws_veg  * ( q_p(k+1,j,i) - q_s       &
+                                    + dq_s_dT * t_surface(j,i) - dq_s_dT       &
+                                    * t_surface_p(j,i) )
+
+                qsws_soil_eb(j,i) = - f_qsws_soil * ( q_p(k+1,j,i) - q_s       &
+                                    + dq_s_dT * t_surface(j,i) - dq_s_dT       &
+                                    * t_surface_p(j,i) )
+
+                qsws_liq_eb(j,i)  = - f_qsws_liq  * ( q_p(k+1,j,i) - q_s       &
+                                    + dq_s_dT * t_surface(j,i) - dq_s_dT       &
+                                    * t_surface_p(j,i) )
              ENDIF
 
-!              IF ( i == 1 .AND. j == 1 )  THEN
-!                 PRINT*, "Rn", Rn(j,i)
-!                  PRINT*, "H", H(j,i)
-!                 PRINT*, "LE", LE(j,i)
-!                 PRINT*, "LE_liq", LE_liq(j,i)
-!                 PRINT*, "LE_veg", LE_veg(j,i)
-!                 PRINT*, "LE_soil", LE_soil(j,i)
-!                 PRINT*, "G", G(j,i)
-!              ENDIF
-
 !
 !--          Calculate the true surface resistance
-             IF ( LE(j,i) .EQ. 0.0 )  THEN
-                r_s(j,i) = 1.0E10
+             IF ( qsws_eb(j,i) .EQ. 0.0_wp )  THEN
+                r_s(j,i) = 1.0E10_wp
              ELSE
-                r_s(j,i) = - rho_lv * ( q_p(k+1,j,i) - q_s + dq_s_dT * T_0(j,i)&
-                           - dq_s_dT * T_0_p(j,i) ) / LE(j,i) - r_a(j,i)
+                r_s(j,i) = - rho_lv * ( q_p(k+1,j,i) - q_s + dq_s_dT           &
+                           * t_surface(j,i) - dq_s_dT * t_surface_p(j,i) )     &
+                           / qsws_eb(j,i) - r_a(j,i)
              ENDIF
-
-!
-!--          Calculate fluxes in the atmosphere
-             shf(j,i) = H(j,i) / rho_cp
 
 !
@@ -967,9 +1183,10 @@
              IF ( humidity )  THEN
 !
-!--             If precipitation is activated, add rain water to LE_liq.
+!--             If precipitation is activated, add rain water to qsws_liq_eb.
 !--             precipitation_rate is given in mm.
                 IF ( precipitation )  THEN
-                   LE_liq(j,i) = LE_liq(j,i) + precipitation_rate(j,i)         &
-                                               * 0.001_wp * rho_l * l_v
+                   qsws_liq_eb(j,i) = qsws_liq_eb(j,i)                         &
+                                       + precipitation_rate(j,i) * 0.001_wp    &
+                                       * rho_l * l_v
                 ENDIF
 !
@@ -977,61 +1194,56 @@
                 IF ( q_s .LE. q_p(k+1,j,i))  THEN
 !
-!--                Check if reservoir is full (avoid values > m_liq_max)
-!--                In that case, LE_liq goes to LE_soil. In this case
-!--                LE_veg is zero anyway (because c_liq = 1), so that tend is
-!--                zero and no further check is needed
-                   IF ( m_liq(j,i) .EQ. m_liq_max )  THEN
-                      LE_soil(j,i) = LE_soil(j,i) + LE_liq(j,i)
-                      LE_liq(j,i) = 0.0_wp
+!--                Check if reservoir is full (avoid values > m_liq_eb_max)
+!--                In that case, qsws_liq_eb goes to qsws_soil_eb. In this 
+!--                case qsws_veg_eb is zero anyway (because c_liq = 1),       
+!--                so that tend is zero and no further check is needed
+                   IF ( m_liq_eb(j,i) .EQ. m_liq_eb_max )  THEN
+                      qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                    &
+                                           + qsws_liq_eb(j,i)
+                      qsws_liq_eb(j,i)  = 0.0_wp
                    ENDIF
 
 !
-!--                In case LE_veg becomes negative (unphysical behavior), let
-!--                the water enter the liquid water reservoir as dew on the
+!--                In case qsws_veg_eb becomes negative (unphysical behavior), 
+!--                let the water enter the liquid water reservoir as dew on the
 !--                plant
-                   IF ( LE_veg(j,i) .LT. 0.0_wp )  THEN
-                      LE_liq(j,i) = LE_liq(j,i) + LE_veg(j,i)
-                      LE_veg(j,i) = 0.0_wp
+                   IF ( qsws_veg_eb(j,i) .LT. 0.0_wp )  THEN
+                      qsws_liq_eb(j,i) = qsws_liq_eb(j,i) + qsws_veg_eb(j,i)
+                      qsws_veg_eb(j,i) = 0.0_wp
                    ENDIF
                 ENDIF                    
   
-                tend = - LE_liq(j,i) * drho_l_lv
-
-                m_liq_p(j,i) = m_liq(j,i) + dt_3d * ( tsc(2) * tend            &
-                                                   + tsc(3) * tm_liq_m(j,i) )
+                tend = - qsws_liq_eb(j,i) * drho_l_lv
+
+                m_liq_eb_p(j,i) = m_liq_eb(j,i) + dt_3d * ( tsc(2) * tend      &
+                                                   + tsc(3) * tm_liq_eb_m(j,i) )
 
 !
 !--             Check if reservoir is overfull -> reduce to maximum
 !--             (conservation of water is violated here)
-                m_liq_p(j,i) = MIN(m_liq_p(j,i),m_liq_max)
+                m_liq_eb_p(j,i) = MIN(m_liq_eb_p(j,i),m_liq_eb_max)
 
 !
 !--             Check if reservoir is empty (avoid values < 0.0)
 !--             (conservation of water is violated here)
-                m_liq_p(j,i) = MAX(m_liq_p(j,i),0.0_wp)
-
-
-!
-!--             Calculate m_liq tendencies for the next Runge-Kutta step
+                m_liq_eb_p(j,i) = MAX(m_liq_eb_p(j,i),0.0_wp)
+
+
+!
+!--             Calculate m_liq_eb tendencies for the next Runge-Kutta step
                 IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( intermediate_timestep_count == 1 )  THEN
-                      tm_liq_m(j,i) = tend
+                      tm_liq_eb_m(j,i) = tend
                    ELSEIF ( intermediate_timestep_count <                      &
                             intermediate_timestep_count_max )  THEN
-                      tm_liq_m(j,i) = -9.5625_wp * tend + 5.3125_wp            &
-                                      * tm_liq_m(j,i)
+                      tm_liq_eb_m(j,i) = -9.5625_wp * tend + 5.3125_wp         &
+                                      * tm_liq_eb_m(j,i)
                    ENDIF
                 ENDIF
 
-!
-!--             Calculate moisture flux in the atmosphere
-                qsws(j,i) = LE(j,i) / rho_lv
-
              ENDIF
 
           ENDDO
        ENDDO
-
-
 
     END SUBROUTINE lsm_energy_balance
@@ -1042,4 +1254,6 @@
 ! ------------
 !
+! Soil model as part of the land surface model. The model predicts soil
+! temperature and water content.
 !------------------------------------------------------------------------------!
     SUBROUTINE lsm_soil_model
@@ -1052,7 +1266,7 @@
        INTEGER(iwp) ::  k   !: running index
 
-       REAL(wp)     :: h_VG !: Van Genuchten coef. h
-
-       REAL(wp), DIMENSION(0:soil_layers-1) :: gamma_temp,  & !: temp. gamma
+       REAL(wp)     :: h_vg !: Van Genuchten coef. h
+
+       REAL(wp), DIMENSION(nzb_soil:nzt_soil) :: gamma_temp,  & !: temp. gamma
                                                lambda_temp, & !: temp. lambda
                                                tend           !: tendency
@@ -1060,16 +1274,16 @@
        DO i = nxlg, nxrg    
           DO j = nysg, nyng
-             DO k = 0, soil_layers-1
+             DO k = nzb_soil, nzt_soil
 !
 !--             Calculate volumetric heat capacity of the soil, taking into 
 !--             account water content 
-                rhoC_total(k,j,i) = (rhoC_soil * (1.0 - m_sat(j,i))            &
-                                     + rhoC_water * m_soil(k,j,i))
+                rho_c_total(k,j,i) = (rho_c_soil * (1.0_wp - m_sat(j,i))       &
+                                     + rho_c_water * m_soil(k,j,i))
 
 !
 !--             Calculate soil heat conductivity at the center of the soil 
 !--             layers
-                Ke = 1.0 + LOG10(MAX(0.1_wp,m_soil(k,j,i) / m_sat(j,i)))
-                lambda_temp(k) = Ke * (lambda_h_sat(j,i) + lambda_h_dry) +     &
+                ke = 1.0_wp + LOG10(MAX(0.1_wp,m_soil(k,j,i) / m_sat(j,i)))
+                lambda_temp(k) = ke * (lambda_h_sat(j,i) + lambda_h_dry) +     &
                                  lambda_h_dry
 
@@ -1079,5 +1293,5 @@
 !--          Calculate soil heat conductivity (lambda_h) at the _stag level 
 !--          using linear interpolation
-             DO k = 0, soil_layers-2
+             DO k = nzb_soil, nzt_soil-1
                   
                 lambda_h(k,j,i) = lambda_temp(k) +                             &
@@ -1086,41 +1300,42 @@
 
              ENDDO
-             lambda_h(soil_layers-1,j,i) = lambda_temp(soil_layers-1)
-
-!
-!--          Prognostic equation for soil temperature T_soil
+             lambda_h(nzt_soil,j,i) = lambda_temp(nzt_soil)
+
+!
+!--          Prognostic equation for soil temperature t_soil
              tend(:) = 0.0_wp
-             tend(0) = (1.0/rhoC_total(0,j,i)) *                               &
-                       ( lambda_h(0,j,i) * ( T_soil(1,j,i) - T_soil(0,j,i) )   &
-                         * ddz_soil(0) + G(j,i) ) * ddz_soil_stag(0)
-
-             DO  k = 1, soil_layers-1
-                tend(k) = (1.0/rhoC_total(k,j,i))                              &
+             tend(0) = (1.0_wp/rho_c_total(nzb_soil,j,i)) *                    &
+                       ( lambda_h(nzb_soil,j,i) * ( t_soil(nzb_soil+1,j,i)     &
+                         - t_soil(nzb_soil,j,i) ) * ddz_soil(nzb_soil)         &
+                         + ghf_eb(j,i) ) * ddz_soil_stag(nzb_soil)
+
+             DO  k = 1, nzt_soil
+                tend(k) = (1.0_wp/rho_c_total(k,j,i))                          &
                           * (   lambda_h(k,j,i)                                &
-                              * ( T_soil(k+1,j,i) - T_soil(k,j,i) )            &
+                              * ( t_soil(k+1,j,i) - t_soil(k,j,i) )            &
                               * ddz_soil(k)                                    &
                               - lambda_h(k-1,j,i)                              &
-                              * ( T_soil(k,j,i) - T_soil(k-1,j,i) )            &
+                              * ( t_soil(k,j,i) - t_soil(k-1,j,i) )            &
                               * ddz_soil(k-1)                                  &
                             ) * ddz_soil_stag(k)
              ENDDO
 
-             T_soil_p(0:soil_layers-1,j,i) = T_soil(0:soil_layers-1,j,i)       &
+             t_soil_p(nzb_soil:nzt_soil,j,i) = t_soil(nzb_soil:nzt_soil,j,i)   &
                                              + dt_3d * ( tsc(2)                &
                                              * tend(:) + tsc(3)                &
-                                             * tT_soil_m(:,j,i) )   
-
-!
-!--          Calculate T_soil tendencies for the next Runge-Kutta step
+                                             * tt_soil_m(:,j,i) )   
+
+!
+!--          Calculate t_soil tendencies for the next Runge-Kutta step
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
-                   DO  k = 0, soil_layers-1
-                      tT_soil_m(k,j,i) = tend(k)
+                   DO  k = nzb_soil, nzt_soil
+                      tt_soil_m(k,j,i) = tend(k)
                    ENDDO
                 ELSEIF ( intermediate_timestep_count <                         &
                          intermediate_timestep_count_max )  THEN
-                   DO  k = 0, soil_layers-1
-                      tT_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp      &
-                                         * tT_soil_m(k,j,i)
+                   DO  k = nzb_soil, nzt_soil
+                      tt_soil_m(k,j,i) = -9.5625_wp * tend(k) + 5.3125_wp      &
+                                         * tt_soil_m(k,j,i)
                    ENDDO
                 ENDIF
@@ -1128,25 +1343,37 @@
 
 
-             DO k = 0, soil_layers-1
+             DO k = nzb_soil, nzt_soil
+
 !
 !--             Calculate soil diffusivity at the center of the soil layers
-                lambda_temp(k) = (- b_CH * gamma_w_sat(j,i) * psi_sat          &
+                lambda_temp(k) = (- b_ch * gamma_w_sat(j,i) * psi_sat          &
                                   / m_sat(j,i) ) * ( MAX(m_soil(k,j,i),        &
-                                  m_wilt(j,i)) / m_sat(j,i) )**(b_CH + 2.0_wp)
-
-!
-!--             Calculate the hydraulic conductivity after Van Genuchten (1980)
-                h_VG = ( ( (m_res(j,i) - m_sat(j,i)) / ( m_res(j,i) -          &
-                           MAX(m_soil(k,j,i),m_wilt(j,i)) ) )**(n_VG(j,i)      &
-                           / (n_VG(j,i)-1.0_wp)) - 1.0_wp                      &
-                       )**(1.0_wp/n_VG(j,i)) / alpha_VG(j,i)
-
-                gamma_temp(k) = gamma_w_sat(j,i) * ( ( (1.0_wp +               &
-                                (alpha_VG(j,i)*h_VG)**n_VG(j,i))**(1.0_wp      &
-                                -1.0_wp/n_VG(j,i)) - (alpha_VG(j,i)*h_VG       &
-                                )**(n_VG(j,i)-1.0_wp))**2 )                    &
-                                / ( (1.0_wp + (alpha_VG(j,i)*h_VG)**n_VG(j,i)  &
-                                )**((1.0_wp - 1.0_wp/n_VG(j,i))*(l_VG(j,i)     &
-                                + 2.0)) )
+                                  m_wilt(j,i)) / m_sat(j,i) )**(b_ch + 2.0_wp)
+
+!
+!--             Parametrization of Van Genuchten
+                IF ( soil_type /= 7 )  THEN
+!
+!--                Calculate the hydraulic conductivity after Van Genuchten 
+!--                (1980)
+                   h_vg = ( ( (m_res(j,i) - m_sat(j,i)) / ( m_res(j,i) -       &
+                              MAX(m_soil(k,j,i),m_wilt(j,i)) ) )**(n_vg(j,i)   &
+                              / (n_vg(j,i)-1.0_wp)) - 1.0_wp                   &
+                          )**(1.0_wp/n_vg(j,i)) / alpha_vg(j,i)
+
+                   gamma_temp(k) = gamma_w_sat(j,i) * ( ( (1.0_wp +            &
+                                   (alpha_vg(j,i)*h_vg)**n_vg(j,i))**(1.0_wp   &
+                                   -1.0_wp/n_vg(j,i)) - (alpha_vg(j,i)*h_vg    &
+                                   )**(n_vg(j,i)-1.0_wp))**2 )                 &
+                                   / ( (1.0_wp + (alpha_vg(j,i)*h_vg           &
+                                   )**n_vg(j,i))**((1.0_wp - 1.0_wp/n_vg(j,i)) &
+                                   *(l_vg(j,i) + 2.0_wp)) )
+
+!
+!--             Parametrization of Clapp & Hornberger
+                ELSE
+                   gamma_temp(k) = gamma_w_sat(j,i) * (m_soil(k,j,i)           &
+                                   / m_sat(j,i) )**(2.0_wp * b_ch + 3.0_wp)
+                ENDIF
 
              ENDDO
@@ -1156,13 +1383,14 @@
 !
 !--             Calculate soil diffusivity (lambda_w) at the _stag level 
-!--             using linear interpolation
-                DO k = 0, soil_layers-2
+!--             using linear interpolation. To do: replace this with
+!--             ECMWF-IFS Eq. 8.81
+                DO k = nzb_soil, nzt_soil-1
                      
                    lambda_w(k,j,i) = lambda_temp(k) +                          &
                                      ( lambda_temp(k+1) - lambda_temp(k) )     &
-                                     * 0.5 * dz_soil_stag(k) * ddz_soil(k+1)
+                                     * 0.5_wp * dz_soil_stag(k) * ddz_soil(k+1)
                    gamma_w(k,j,i)  = gamma_temp(k) +                           &
                                      ( gamma_temp(k+1) - gamma_temp(k) )       &
-                                     * 0.5 * dz_soil_stag(k) * ddz_soil(k+1)                 
+                                     * 0.5_wp * dz_soil_stag(k) * ddz_soil(k+1)                 
 
                 ENDDO
@@ -1174,63 +1402,70 @@
 !--             in the bottom layer.
                 IF ( conserve_water_content )  THEN
-                   gamma_w(soil_layers-1,j,i) = 0.0_wp
+                   gamma_w(nzt_soil,j,i) = 0.0_wp
                 ELSE
-                   gamma_w(soil_layers-1,j,i) = lambda_temp(soil_layers-1)
+                   gamma_w(nzt_soil,j,i) = lambda_temp(nzt_soil)
                 ENDIF     
 
-!--             The root extraction (= root_extr * LE_veg / (rho_l * l_v))
+!--             The root extraction (= root_extr * qsws_veg_eb / (rho_l * l_v))
 !--             ensures the mass conservation for water. The transpiration of
 !--             plants equals the cumulative withdrawals by the roots in the 
 !--             soil. The scheme takes into account the availability of water
 !--             in the soil layers as well as the root fraction in the
-!--             respective layer
-
-!
-!--             Calculate the root extraction (ECMWF 7.69, with some
-!--             modifications)
+!--             respective layer. Layer with moisture below wilting point will
+!--             not contribute, which reflects the preference of plants to
+!--             take water from moister layers.
+
+!
+!--             Calculate the root extraction (ECMWF 7.69, modified so that the
+!--             sum of root_extr = 1). The energy balance solver guarantees a 
+!--             positive transpiration, so that there is no need for an 
+!--             additional check.
+
                 m_total = 0.0_wp
-                DO k = 0, soil_layers-1
-                    m_total = m_total + root_fr(k,j,i) * m_soil(k,j,i) *       &
-                              dz_soil_stag(k) 
-
+                DO k = nzb_soil, nzt_soil
+                    IF ( m_soil(k,j,i) .GT. m_wilt(j,i) )  THEN
+                       m_total = m_total + root_fr(k,j,i) * m_soil(k,j,i)
+                    ENDIF
                 ENDDO  
 
-!
-!--             For conservation of mass, the sum of root_extr must be 1
-                DO k = 0, soil_layers-1 
-                   root_extr(k) = root_fr(k,j,i) * m_soil(k,j,i)               &
-                                  * dz_soil_stag(k) / m_total
+                DO k = nzb_soil, nzt_soil 
+                   IF ( m_soil(k,j,i) .GT. m_wilt(j,i) )  THEN
+                      root_extr(k) = root_fr(k,j,i) * m_soil(k,j,i) / m_total
+                   ELSE
+                      root_extr(k) = 0.0_wp
+                   ENDIF
                 ENDDO
-
 
 !
 !--             Prognostic equation for soil water content m_soil
                 tend(:) = 0.0_wp
-                tend(0) = ( lambda_w(0,j,i) * ( m_soil(1,j,i) - m_soil(0,j,i) )&
-                            * ddz_soil(0) - gamma_w(0,j,i) - ( root_extr(0)    &
-                            * LE_veg(j,i) + LE_soil(j,i) ) * drho_l_lv         &
-                          ) * ddz_soil_stag(0)
-
-                DO  k = 1, soil_layers-2
+                tend(nzb_soil) = ( lambda_w(nzb_soil,j,i) * (                  &
+                            m_soil(nzb_soil+1,j,i) - m_soil(nzb_soil,j,i) )    &
+                            * ddz_soil(nzb_soil) - gamma_w(nzb_soil,j,i) - (   &
+                            root_extr(nzb_soil) * qsws_veg_eb(j,i)             &
+                            + qsws_soil_eb(j,i) ) * drho_l_lv )                &
+                            * ddz_soil_stag(nzb_soil)
+
+                DO  k = nzb_soil+1, nzt_soil-1
                    tend(k) = ( lambda_w(k,j,i) * ( m_soil(k+1,j,i)             &
                                - m_soil(k,j,i) ) * ddz_soil(k) - gamma_w(k,j,i)&
                                - lambda_w(k-1,j,i) * (m_soil(k,j,i) -          &
                                m_soil(k-1,j,i)) * ddz_soil(k-1)                &
-                               + gamma_w(k-1,j,i) - (root_extr(k) * LE_veg(j,i)&
-                               * drho_l_lv)                                    &
+                               + gamma_w(k-1,j,i) - (root_extr(k)              &
+                               * qsws_veg_eb(j,i) * drho_l_lv)                 &
                              ) * ddz_soil_stag(k)
 
                 ENDDO
-                tend(soil_layers-1) = ( - gamma_w(soil_layers-1,j,i)           &
-                                        - lambda_w(soil_layers-2,j,i)          &
-                                        * (m_soil(soil_layers-1,j,i)           &
-                                        - m_soil(soil_layers-2,j,i))           &
-                                        * ddz_soil(soil_layers-2)              &
-                                        + gamma_w(soil_layers-2,j,i) - (       &
-                                          root_extr(soil_layers-1)             &
-                                        * LE_veg(j,i) * drho_l_lv      )       &
-                                      ) * ddz_soil_stag(soil_layers-1)             
-
-                m_soil_p(0:soil_layers-1,j,i) = m_soil(0:soil_layers-1,j,i)    &
+                tend(nzt_soil) = ( - gamma_w(nzt_soil,j,i)                     &
+                                        - lambda_w(nzt_soil-1,j,i)             &
+                                        * (m_soil(nzt_soil,j,i)                &
+                                        - m_soil(nzt_soil-1,j,i))              &
+                                        * ddz_soil(nzt_soil-1)                 &
+                                        + gamma_w(nzt_soil-1,j,i) - (          &
+                                          root_extr(nzt_soil)                  &
+                                        * qsws_veg_eb(j,i) * drho_l_lv  )      &
+                                      ) * ddz_soil_stag(nzt_soil)             
+
+                m_soil_p(nzb_soil:nzt_soil,j,i) = m_soil(nzb_soil:nzt_soil,j,i)&
                                                 + dt_3d * ( tsc(2) * tend(:)   &
                                                 + tsc(3) * tm_soil_m(:,j,i) )   
